*-----------------------------------------------------------------------
*-- File........: CRPEWrap.H
*-- Programmer..: Bowen Moursund (CIS: 72662,436), Copyright 1997
*-- Date........: 02/28/97
*-- Notes.......: CRPE.DLL function prototypes, etc.
*-----------------------------------------------------------------------

*-- Misc. defines
*-- Used in SetButtonTop method of preview window form class
#define PW_BUTTONBOTTMARGIN 2.3

*-- page orientation selections
#define DMORIENT_PORTRAIT   1
#define DMORIENT_LANDSCAPE  2

*----------------------------------------------------------------------
*-- Print engine management
*----------------------------------------------------------------------
#define PE_GV_DLL       100   && returns version of DLL
#define PE_GV_ENGINE    200   && returns version of print engine
if type("PEOpenEngine") <> "FP"
    extern CLOGICAL PEOpenEngine(CVOID) CRPE.DLL
endif
if type("PECloseEngine") <> "FP"
    extern CVOID    PECloseEngine(CVOID) CRPE.DLL
endif
if type("PEGetVersion") <> "FP"
    extern CWORD    PEGetVersion(CWORD) CRPE.DLL
endif
*-- Added this one so can adjust line height (dwl)
*-- This allows simulation of ss/ds/ts.
if type("PESetLineHeight") <> "FP"
    extern CLOGICAL PESetLineHeight(CWORD, CWORD, CWORD,;
                                    CWORD, CWORD) CRPE.DLL
endif

*----------------------------------------------------------------------
*-- Print job management
*----------------------------------------------------------------------
if type("PEPrintReport") <> "FP"
    extern CWORD    PEPrintReport(CSTRING, CLOGICAL, CLOGICAL,;
                                  CSTRING, CWORD,  CWORD, CWORD,;
                                  CWORD, CLONG, CHANDLE) CRPE.DLL
endif

if type("PEOpenPrintJob") <> "FP"
    *-- parm 1, CSTRING = path/filename of report file
    extern CWORD    PEOpenPrintJob(CSTRING) CRPE.DLL
endif

if type("PEStartPrintJob") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 1, CLOGICAL = wait until done (pass as .T.)
    extern CLOGICAL PEStartPrintJob(CWORD,;
                                    CLOGICAL) CRPE.DLL
endif

if type("PEClosePrintJob") <> "FP"
    *-- parm 1, CWORD = print job handle
    extern CLOGICAL PEClosePrintJob(CWORD) CRPE.DLL
endif

if type("PECancelPrintJob") <> "FP"
    *-- parm 1, CWORD = print job handle
    extern CVOID PECancelPrintJob(CWORD) CRPE.DLL
endif

if type("PESetPrintOptions") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CPTR = print options structure
    extern CLOGICAL PESetPrintOptions(CWORD, CPTR) CRPE.DLL
endif
*-- The CRW print options structure is 10 bytes, composed of 5 16-bit
*-- integer fields:
*--
*--         Structure size (set to 10)
*--         Start page
*--         Stop page
*--         Report Copies
*--         Collation
*--
*-- print options structure in VB
*-- Structure
*-- Type PEPrintOptions
*--     structSize As Integer
*--     startPageN As Integer
*--     stopPageN As Integer
*--     nReportCopies As Integer
*--     collation As Integer
*-- End Type
*-- collation setting
#define PE_UNCOLLATED       0 && Prints multiple copies of a multiple
                              && page report in page order 1,1,1,,
                              && 2,2,2,, 3,3,3,, etc.
#define PE_COLLATED         1 && Prints multiple copies of a multiple
                              && page report in page order 1,2,3,, ...
                              && 1,2,3,...,, 1,2,3...,, etc.
#define PE_DEFAULTCOLLATION 2 && Prints multiple copies of a multiple
                              && page report using the collation
                              && specification from the print section of
                              && the control panel.
*-- Added this one (dwl).  It's used in the procedure that calls
*--                        PESetLineHeight
#define PE_TWIPSPERLINE   240 && 240 twips = 1 line at 12 pitch

*----------------------------------------------------------------------
*-- Print destinations
*----------------------------------------------------------------------
if type("PEOutputToPrinter") <> "FP"
    *-- parm 1, CWORD - print job handle
    *-- parm2, CWORD = number of copies
    extern CLOGICAL PEOutputToPrinter(CWORD,CWORD) CRPE.DLL
endif

if type("PESelectPrinter") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CSTRING = printer driver name
    *-- parm 3, CSTRING = printer name
    *-- parm 4, CSTRING = port name
    *-- parm 5, CPTR = DEVMODE structure
    extern CLOGICAL PESelectPrinter(CWORD, CSTRING, CSTRING,;
                                    CSTRING, CPTR) CRPE.DLL
endif

*-- Constants for STYLE param of PEOutputToWindow --*
#define WS_CLIPSIBLINGS         67108864
#define WS_CLIPCHILDREN         33554432
#define WS_VISIBLE              268435456
#define WS_DISABLED             134217728
#define WS_MINIMIZE             536870912
#define WS_MAXIMIZE             16777216
#define WS_CAPTION              12582912
#define WS_BORDER               8388608
#define WS_DLGFRAME             4194304
#define WS_VSCROLL              2097152
#define WS_HSCROLL              1048576
#define WS_SYSMENU              524288
#define WS_THICKFRAME           262144
#define WS_MINIMIZEBOX          131072
#define WS_MAXIMIZEBOX          65536

#define CW_USEDEFAULT           -32768

if type("PEOutputToWindow") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CSTRING = window title
    *-- parm 3, CWORD = left
    *-- parm 4, CWORD = top
    *-- parm 5, CWORD = width
    *-- parm 6, CWORD = height
    *-- parm 7, CLONG = style
    *-- parm 8, CHANDLE = parent form handle
    extern CLOGICAL PEOutputToWindow(CWORD, CSTRING, CWORD,;
                                     CWORD, CWORD, CWORD, CLONG,;
                                     CHANDLE) CRPE.DLL
endif

*----------------------------------------------------------------------
*-- Print window stuff
*----------------------------------------------------------------------
if type("PEGetWindowHandle") <> "FP"
    extern CHANDLE PEGetWindowHandle(CWORD) CRPE.DLL
endif

if type("PEPrintWindow") <> "FP"
    extern CLOGICAL PEPrintWindow(CWORD,CLOGICAL) CRPE.DLL
endif

if type("PEShowPrintControls") <> "FP"
    extern CLOGICAL PEShowPrintControls(CWORD,;
                                        CLOGICAL) CRPE.DLL
endif

if type("PEShowNextPage") <> "FP"
    extern CLOGICAL PEShowNextPage(CWORD) CRPE.DLL
endif

if type("PEShowFirstPage") <> "FP"
    extern CLOGICAL PEShowFirstPage(CWORD) CRPE.DLL
endif

if type("PEShowPreviousPage") <> "FP"
    extern CLOGICAL PEShowPreviousPage(CWORD) CRPE.DLL
endif

if type("PEShowLastPage") <> "FP"
    extern CLOGICAL PEShowLastPage(CWORD) CRPE.DLL
endif

if type("PEZoomPreviewWindow") <> "FP"
    extern CLOGICAL PEZoomPreviewWindow(CWORD, CINT) CRPE.DLL
endif

if type("PENextPrintWindowMagnification") <> "FP"
    extern CLOGICAL PENextPrintWindowMagnification(CWORD) CRPE.DLL
endif



*----------------------------------------------------------------------
*-- Error management
*----------------------------------------------------------------------
if type("PEGetErrorCode") <> "FP"
    extern CWORD    PEGetErrorCode(CWORD) CRPE.DLL
endif

*----------------------------------------------------------------------
*-- Table management
*----------------------------------------------------------------------
if type("PEGetNTables") <> "FP"
    extern CWORD PEGetNTables(CWORD) CRPE.DLL
endif

if type("PEGetNthTableLocation") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CWORD = table number
    *-- parm 3, CSTRING = string to simulate PETableLocation structure
    extern CLOGICAL PEGetNthTableLocation(CWORD, CWORD,;
                                          CSTRING) CRPE.DLL
endif

*----------------------------------------------------------------------
*-- Export
*----------------------------------------------------------------------
if type("PEGetExportOptions") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CPTR = PEExportOptions structure
    extern CLOGICAL PEGetExportOptions(CWORD, CPTR) CRPE.DLL
endif
if type("PEExportTo") <> "FP"
    *-- parm 1, CWORD = print job handle
    *-- parm 2, CPTR = PEExportOptions structure
    extern CLOGICAL PEExportTo(CWORD, CPTR) CRPE.DLL
endif

*-- EoF: CRPEWrap.H
